#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu May 31 14:52:38 2018

@author: lmasson
"""

import parse_rsm
from subprocess  import call
import utils
import simplif_gene_perm_impact

#########################################################################
class Result_reach:
   def __init__(self, state_id, is_reach):
      self.state_id=state_id
      self.is_reach=is_reach

######################################################################### 
class State:
   def __init__(self, id, vars_names, vars_values, state_def):
      self.id=id
      self.vars_names=vars_names
      self.vars_values=vars_values
      self.state_def=state_def
######################################################################### 
class DepartureState:
   def __init__(self, state_id, interv_id, dep_st_interv_def):
      self.state_id=state_id
      self.interv_id=interv_id
      self.dep_st_interv_def=dep_st_interv_def

######################################################################### 
class Result_pairs:
   def __init__(self, st_arrival_id, dep_state):
      self.st_arrival_id=st_arrival_id
      self.dep_state=dep_state
      

#########################################################################
def check_gene_perm(model_name):
   call('NuSMV -source '+model_name+'.Areach '+model_name+'.auto.smv > result_gene_perm', shell=True)

#########################################################################
def check_gene_perm_read_result(result_file_name, mode, states_structure, names_intervs):
   results_gene_simple_structure=[]
   results_gene_univ_structure=[]
   results_univ_pairs_structure=[]
   lines=utils.read_lines(result_file_name)
   first_line=1
   for l in lines:
#      print(l.split(" ")[-1].rstrip())
      if (l.split(" ")[-1].rstrip()=="true" or l.split(" ")[-1].rstrip()=="false") and first_line==1:
         first_line=0
         index_first=lines.index(l)
   #         print("\nfirst line of result is at line "+str(index_first))

      ##TRUE:
      if l.split(" ")[-1].rstrip()=="true":
         index=lines.index(l)
         l=l.split(" is true")[0]
         if mode=="liveprop":
#            print("Property "+str(index)+" is true")
            l=l.split("live_")[-1]
            if index_first % 2 == index % 2:
               results_gene_simple_structure.append(Result_reach(int(l), "true"))
            elif index_first % 2 != index % 2:
               results_gene_univ_structure.append(Result_reach(int(l), "true"))
#         if mode == 'univ_pairs':
##            print("State def in line: "+l)   
#            for s in states_structure:
#               if s.state_def==l:
##                  print(s.state_def)                  
#                  results_univ_pairs_structure.append(Result_reach(s.id,"true")) 
##                  print(str(s.id) + "true")
      ##FALSE:                  
      if l.split(" ")[-1].rstrip()=="false":
         index=lines.index(l)
         l=l.split(" is false")[0]
         if mode == 'liveprop':
#            print("Property "+str(index)+" is false")
            l=l.split("live_")[-1]
            if index_first % 2 == index % 2:
               results_gene_simple_structure.append(Result_reach(int(l), "false"))
            elif index_first % 2 != index % 2:
               results_gene_univ_structure.append(Result_reach(int(l), "false"))
         if mode == 'univ_pairs':
            dep_st_id=''
            interv_id=''
            l=l.split("-- specification EF ((")[-1]
            l=l.split(") & EX ")[0]
            l=l.rstrip().replace(" ","")
            l=l.replace("(","")
            l=l.replace(")","")
#            print("State def in line: "+l)
            for s in states_structure:
               if s.state_def in l:
                  dep_st_id=s.id
            for i in names_intervs:
               if i in l:
                  interv_id=names_intervs.index(i)
#            print('Corresponding state number: '+str(dep_st_id))
#            print('Corresponging interv number: '+str(interv_id))
            results_univ_pairs_structure.append(DepartureState(dep_st_id, interv_id, l))
#                  print(str(s.id) + "false")
   return results_gene_simple_structure, results_gene_univ_structure, results_univ_pairs_structure

#########################################################################
def check_gene_perm_print_result(results_gene_simple_structure, results_gene_univ_structure):
   for r in results_gene_simple_structure:
      print("Simple permissiveness for state "+str(r.state_id)+" is "+r.is_reach+"\n")
   for r in results_gene_univ_structure:
      print("Universal permissiveness for state "+str(r.state_id)+" is "+r.is_reach+"\n")

#########################################################################
def check_gene_perm_get_states_def(model_name):
   states_structure=[]
   lines=utils.read_lines(model_name+".auto.smv")
   for l in lines:
      if l[0:5]=="live_":
         id=int(l[5:].split(":")[0].strip())
#         print(id)
         vars_names=[]
         vars_values=[]
         state_def=[]
#         print("this is a LiveProp def line\n")
         l=l.split("LiveProp( ")[-1].strip()
         l=l.split(", mdiag")[0].strip()
         state_def_str=l.replace(" ","")
#         print(l+"\n")
         if "&" in l:
            state_def=l.split("&")
         else:
            state_def=l
#         print(state_def)
         for s in state_def:
            vars_names.append(s.split("=")[0].strip())
            vars_values.append(s.split("=")[-1].strip())
#         print(vars_names)
#         print(vars_values)
         states_structure.append(State(id, vars_names, vars_values, state_def_str))
#   print("States Structure is:")
#   for s in states_structure:
#      print(s.id)
#      print(s.vars_names)
#      print(s.vars_values)
#      print(s.state_def)
   print("Total: "+str(len(states_structure))+" states")
   return states_structure

#########################################################################
def check_gene_perm_check_univ_pairs(results_gene_simple_structure, result_gene_univ_structure, states_structure, model_name, warn_states_structure, names_intervs):
   results_no_univ_global_structure=[]
   state_no_univ_def=""
   for r in result_gene_univ_structure:
      if r.is_reach=="false":
#         print(str(r.state_id)+' is false')
#         for rs in results_gene_simple_structure:
#            if rs.state_id==r.state_id and rs.is_reach=="true":
         state_no_univ_def=""
#         print("\nChecking state "+str(r.state_id)+": \n")
         open("script_univ_perm","w").close()
         ##Writes the definition of the non univ reachable state that is being checked
         for s in states_structure:
            if s.id==r.state_id:
               state_no_univ_def=s.state_def
#               print("\n "+state_no_univ_def)
         script_univ_perm=open("script_univ_perm","w")
         script_univ_perm.write("set counter_examples 0 \ngo \n")
         #######TO CHANGE FOR WARNING STATES ONLY 
         for ws in warn_states_structure:
            ws_def_str=''
            for v in ws.variables:
               ws_def_str+=v.name+' = '+v.value
               if ws.variables.index(v)!=ws.variables.index(ws.variables[-1]):
                  ws_def_str+=' & '            
            for i in range(len(ws.state_interv)):
               if ws.state_interv[i]==1:
                  ws_interv_def_str=''
                  for j in range(len(names_intervs)):
                     if i==j:
                        ws_interv_def_str=ws_def_str+' & '+names_intervs[j]+'.activ'
                        script_univ_perm.write("check_ctlspec -p \" EF("+ws_interv_def_str+" & EX(EF("+state_no_univ_def+")))\" \n")
#                        print("Wrote in script:\n")
#                        print("check_ctlspec -p \" EF("+s.state_def+" & EF("+state_no_univ_def+"))\" \n")
         ###########
         script_univ_perm.write("quit\n")               
         script_univ_perm.close()     
         call('NuSMV -source script_univ_perm '+model_name+'.auto.smv > result_pairs_univ_perm', shell=True)
         _, _, results_univ_pairs_structure=check_gene_perm_read_result('result_pairs_univ_perm', 'univ_pairs', states_structure, names_intervs) ##Stores only the def of the states+interv that don't reach considered state
#         for p in results_univ_pairs_structure:
#            print('From state '+str(p.state_id)+' with interv '+str(p.interv_id)+': not path to state '+str(r.state_id))
         results_no_univ_global_structure.append(Result_pairs(r.state_id, results_univ_pairs_structure))
   return results_no_univ_global_structure

#########################################################################
def store_permissiveness_impact_in_file(results_no_univ_global_structure, model_name, warn_states_structure, states_structure):
   model_pi=open(model_name+".pi", "a")
   model_pi.write("0\n")
   ##For every non reachable state
   for r in results_no_univ_global_structure:
      ##Write the non reached state definition:
      for s in states_structure:
         if r.st_arrival_id==s.id:
            model_pi.write(s.state_def +'\n')
      ##For every state+interv from which no path exist to the considered arrival state
      for dst in r.dep_state:
#         print("Considered departure state: "+dst.dep_st_interv_def)
         for s in states_structure:
            if dst.state_id==s.id:
#               print("Corresponds to the state "+str(s.id)+" in the list of all states")
#               print("Looking for the id of the corresponding warning state:")
               for wst in warn_states_structure:
                  wstate_def=''                  
                  for var in wst.variables:
                     if wst.variables.index(var)!=len(wst.variables)-1:
                        wstate_def+=str(var.name)+"="+str(var.value)+"&"
                     if wst.variables.index(var)==len(wst.variables)-1:
                        wstate_def+=str(var.name)+"="+str(var.value)
#                  print("Warning state def: "+wstate_def)   
                  if s.state_def.strip()==wstate_def.strip():
                     model_pi.write(str(wst.id)+" "+str(dst.interv_id)+"\n")   
   model_pi.close()


#########################################################################
def check_gene_main(model_name, warn_states_structure):
   ##Get rms data
   variables_structure, nb_var, names_intervs, nb_interv, nb_states = parse_rsm.parse_rsm(model_name)
#   print("Got data from rsm file")
   ##Read states definitions from list of LiveProps
   states_structure=check_gene_perm_get_states_def(model_name)
#   print("Got states definitions")
   ##Checks the LiveProps for simple and universal permissiveness
   check_gene_perm(model_name) 
   print("Checked generic permissivess properties from LiveProp")
   ##Read result from generated result file
   results_gene_simple_structure, results_gene_univ_structure, _=check_gene_perm_read_result('result_gene_perm', 'liveprop', states_structure, names_intervs)
#   print("Read results of permissiveness check")   
   ##For non univ reachable states, check from which state they're not reachable, read result and store
   results_no_univ_global_structure=check_gene_perm_check_univ_pairs(results_gene_simple_structure, results_gene_univ_structure, states_structure, model_name, warn_states_structure, names_intervs)
   print("Checked pairs for universal reachability")  
#   for state_no_univ in results_no_univ_global_structure:
#      print("For state "+str(state_no_univ.st_arrival_id)+": ")
#      for p_r in state_no_univ.dep_state_def:
#         print("State "+str(p_r.state_id)+": "+p_r.is_reach+"\n")
#   #Print results
#   check_gene_perm_print_result(results_gene_simple_structure, results_gene_univ_structure)
   store_permissiveness_impact_in_file(results_no_univ_global_structure, model_name, warn_states_structure, states_structure)
   #Simplify the results
   simplif_gene_perm_impact.simplif_gene_main(variables_structure, states_structure, results_gene_simple_structure, results_no_univ_global_structure, nb_var, model_name, names_intervs)