#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun May 27 17:41:55 2018

@author: lmasson
"""
import utils 

class Variable:
    def __init__(self, name, bound):
        self.name = name
        self.bound = bound



##Parse .rsm 
def parse_rsm(model_name):
   variables_structure=[]
   names_intervs=[]
   model_rsm=model_name + ".rsm"
   lines_rsm=utils.read_lines(model_rsm)
   nb_interv=int(lines_rsm[0])
   for j in range(1, nb_interv+1):
      names_intervs.append(lines_rsm[j].rstrip())
   nb_var=int(lines_rsm[nb_interv+1])
   for i in range(nb_interv+2, nb_interv+nb_var+2):
      line_var_i=lines_rsm[i]
      name_var_i=line_var_i.split(".v")[0]
      bound_var_i=line_var_i.split(" ")[-1]
      variable_i=Variable(name_var_i, bound_var_i)
      variables_structure.append(variable_i)
#      print("Var number "+str(i-2)+"\n")
#      print("\t name: "+variable_i.name+"\t bound: "+variable_i.bound)
#   print("Names of interventions: "+str(list(names_intervs)))
   nb_states=calc_nb_states(variables_structure)
   return variables_structure, nb_var, names_intervs, nb_interv, nb_states

def calc_nb_states(variables_structure):
   nb_states=1
   for v in variables_structure:
      nb_states*=(int(v.bound)+1)
   return nb_states