#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Apr 18 13:50:06 2018

@author: lmasson
"""

import parse_strategy as parse_strat
import parse_fct as parse_fct
import check_impact_states_intervs as check_impact
import check_impact_generic_perm as check_impact_gene
import utils
## Read in File (given on command line)
import sys
if (len(sys.argv) != 2):
    print("Oops, I was expecting you to give a file name.")
    print("\n  Usage: python main.py model.res\n")
    sys.exit()

def read_lines(model):
    with open(model) as f:
        lines = f.readlines()
    return lines

model = sys.argv[1] # grab first argument on command line

(lines) = read_lines(model)
model_name=model.split(".res")[0] #get the name of the  model without the .res extension
##fill the data structures:
(relevant_lines, state_lines, warn_states_structure, interventions_structure) = parse_strat.parse_strategy(lines) 
#parse_strat.print_strategy_data(warn_states_structure, interventions_structure)

#read the functionalities
model_fct=model_name+".fct"
(lines_fct)=read_lines(model_fct)
fct_structure, use_fct=parse_fct.parse_fct(lines_fct)

parse_fct.print_fct_data(fct_structure)

#############################Clean files
open("model_copy.smv","w").close()
open("model_and_strategy.smv", "w").close()
open(model_name+".impact.smv","w").close()

model_smv=model_name + ".smv"
model=open(model_smv,"r")

model_copy=open("model_copy.smv","w")
model_copy.write(model.read())
model_copy.close()

model_copy=open("model_copy.smv","a")
for l in state_lines:
    model_copy.write(l)
model_copy.close()
model.close()


model=open(model_smv,"r")
model_and_strategy=open("model_and_strategy.smv", "w")
model_and_strategy.write(model.read())
model_and_strategy.close()

model_and_strategy=open("model_and_strategy.smv", "a")
for l in relevant_lines:
   model_and_strategy.write(l)
model_and_strategy.close()
model.close()


open(model_name+".pi","w").close()
if use_fct==1:
   #check impact intervs for each functionality
   for fct in fct_structure:
      if fct.status!=0:
         print("For functionality " +fct.name+ ", the analysis results are:")
         check_impact.check_impact_main(model_name, warn_states_structure, interventions_structure,  fct)
         print("")
else:
   check_impact_gene.check_gene_main(model_name, warn_states_structure)



