#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon May 28 17:40:40 2018

@author: lmasson
"""
import sys
sys.path.append('/home/lmasson/Documents/z3-master/build/python')
from z3 import *
import re

def parse_smt(file_name):
   parse_result=z3.parse_smt2_file(file_name)
   parse_result=" ".join(str(parse_result).split())
#   print("Result of parsing: "+str(parse_result))
   return str(parse_result)

def write_smv_from_smt(parse_result, names_intervs ):##Returns an array of terms, the whole formula is an OR of the lines of the array
   terms_smv=[]
   if 'Or' in parse_result:
#      exists_or=1
      parse_result=parse_result.split('Or(')[-1].rsplit(')',1)[0]
   parse_result_terms=re.split(r',\s*(?![^()]*\))', parse_result)
#   print("Terms of parsed expression:")
#   for i in range(len(parse_result_terms)):
#      print(parse_result_terms[i])
   for term in parse_result_terms:
      if 'And' in  term:
         term_smv=''
#         print("\nIn AND expression:")
         and_terms=term.split('And(')[-1].split(', ')[:]
#         print(and_terms)
         for j in range(len(and_terms)):
            if ')' in and_terms[j]:
               and_terms[j]=and_terms[j].rsplit(')')[0]
               name_var=and_terms[j].split(' == ')[0]
#               print(name_var)
               val_var=and_terms[j].split(' == '+name_var)[-1]
               if any(name_var in ni for ni in names_intervs):
                   term_smv+=name_var+'.activ '
               else:
                   term_smv+=name_var+'.v = '+val_var
#               print(term_smv)
            else: 
               name_var=and_terms[j].split(' == ')[0]
#               print(name_var)
               val_var=and_terms[j].split(' == '+name_var)[-1]
               if any(name_var in ni for ni in names_intervs):
                   term_smv+=name_var+'.activ'+' & '               
               else:
                   term_smv+=name_var+'.v = '+val_var+' & '               
#               print(term_smv, end='')
      else:
#         print("\nIn single term expression:")
         name_var=term.split(' == ')[0]
         val_var=term.split(' == '+name_var)[-1]
#         print(name_var)
         if any(name_var in ni for ni in names_intervs):
             term_smv=name_var+'.activ'
         else:
             term_smv=name_var+'.v = '+val_var
#         print(term_smv)   
      terms_smv.append(term_smv)
   return terms_smv

def read_lines(model):
    with open(model) as f:
        lines = f.readlines()
    return lines
 
def is_int(obj):
   try: 
      int(obj)
      return True
   except ValueError:
      return False