#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Jun 12 16:02:35 2018

@author: lmasson
"""
from subprocess import call
import utils
import copy 
import simplif_impact 
import numpy as np

class ResultSimpl:
   def __init__(self, arrival_state_id, result_simpl):
      self.arrival_state_id=arrival_state_id
      self.result_simpl=result_simpl

class SameDeparture:
   def __init__(self, departure_predicate, arrival_states_ids):
      self.departure_predicate=departure_predicate
      self.arrival_states_ids=arrival_states_ids

class ResultDepartureArrival:
   def __init__(self, result_simpl_departure, result_simpl_arrival):
      self.result_simpl_departure=result_simpl_departure
      self.result_simpl_arrival=result_simpl_arrival


##Write in smt format the declaration of variables
def simplif_gene_declare_vars(variables_structure):
   vars_declaration=open("vars_declaration.smt","w")
   for v in variables_structure:
      vars_declaration.write("(declare-datatypes () (( "+v.name+"TYPE ")
      for n in range(0,int(v.bound)+1):
         vars_declaration.write(v.name+str(n)+" ")
      vars_declaration.write(")))\n")
      vars_declaration.write("(declare-fun "+v.name+" () "+v.name+"TYPE )\n")
   vars_declaration.close()

##Write in smt format the declaration of interventions   
def simplif_gene_declare_intervs(names_intervs):
   open("interv_declaration.smt", "w").close()
   interv_declaration=open("interv_declaration.smt", "w")
   for n in range(len(names_intervs)):
      interv_declaration.write("(declare-datatypes () (( "+names_intervs[n].rstrip()+"TYPE "+names_intervs[n].rstrip()+"0 "+names_intervs[n].rstrip()+"1 )))\n") #interv value = 0 if not activ
      interv_declaration.write("(declare-fun "+names_intervs[n].rstrip()+" () "+names_intervs[n].rstrip()+"TYPE )\n")
   interv_declaration.close()

##Write in smt format the result of the check of generic permissiveness
def simplif_gene_declare_gene_perm_result(states_structure, results_structure, mode, names_intervs):
   open("gene_perm_"+mode+"_declaration.smt","w").close()
   
   result_simple_declaration=open("gene_perm_"+mode+"_declaration.smt", "w")
   result_simple_declaration.write("(assert \n")
   result_simple=[]
   result_simple_lines=[]


   for r in results_structure:
      result_simple=[]      
      formula_part_1=[]
      formula_part_2=[]
      formula_part_3=''
      if mode!='departure_states' and r.is_reach=="false" or mode=='departure_states':
#         print("State "+str(r.state_id)+" doesn't reach considered state")
         for s in states_structure:
            if int(r.state_id)==int(s.id):
               for v_n in s.vars_names:
                  formula_part_1.append("(= "+v_n.split(".v")[0]+" "+v_n.split(".v")[0])
               for v_v in s.vars_values:
                  formula_part_2.append(v_v+") ")
         if mode=='departure_states':
            formula_part_3='(= '+names_intervs[r.interv_id]+' '+ names_intervs[r.interv_id]+'1)'
         for i in range(len(formula_part_1)):
#            print('Variables: ')
#            print(formula_part_1[i]+formula_part_2[i])
            result_simple.append(formula_part_1[i]+formula_part_2[i])
         result_simple.append(formula_part_3)
#         print('Result to simplify: ')
#         print(list(result_simple))

      if len(result_simple)>1:
         result_simple_lines.append("\t\t(and "+(" ").join(result_simple)+")\n")
      if len(result_simple)==1:
         result_simple_lines.append(result_simple[0]+"\n")

   if len(result_simple_lines)>1:
      result_simple_declaration.write("\n\t(or\n")
   if len(result_simple_lines)!=0:
      for l in result_simple_lines:
         result_simple_declaration.write(l)
   if len(result_simple_lines)>1:
      result_simple_declaration.write("\t)\n") 
         

            
   result_simple_declaration.write(")\n")
   result_simple_declaration.write("(apply ctx-solver-simplify)\n")
   result_simple_declaration.close()
   


def simplif_gene_simplify(nb_var, mode): ##TODO no return needed anymore
   vars_declaration=open("vars_declaration.smt","r")
   if mode=='departure_states':
      interv_declaration=open('interv_declaration.smt','r')
   gene_perm_to_simplify=open('gene_perm_to_simplify_'+mode+'.smt',"w")
   gene_perm_to_simplify.write(vars_declaration.read())
   if mode=='departure_states':
      gene_perm_to_simplify.write(interv_declaration.read())
      interv_declaration.close()
   result_declaration=open("gene_perm_"+mode+"_declaration.smt", "r")
   gene_perm_to_simplify.write(result_declaration.read())
   result_declaration.close()
   gene_perm_to_simplify.close()
   vars_declaration.close()   
   n=0
   call('z3 gene_perm_to_simplify_'+mode+'.smt > result_simplif_gene_perm_'+mode, shell=True)
   if mode=='univ':
      call('cp result_simplif_gene_perm_'+mode+' first_result_simplif_gene_perm_'+mode, shell=True)
   ##Read result of simplification
   result_simpl='result_simplif_gene_perm_'+mode
   (lines) = utils.read_lines(result_simpl)
#   print(list(lines))
   result_simpl_first=lines[2:-2]
   result_simpl_before=copy.copy(result_simpl_first)
#   print("Lines before:\n")
#   print(result_simpl_first)
#   print(len(result_simpl_simple_first))
#   print(nb_var)
   ## If the predicate to simplify has more parts than variables (at least a or operator)
   if "or" in result_simpl_first[0] or "and" in result_simpl_first[0]:
#      print("\nFirst simplification potentially not minimal")
      result_simpl_after=[]
#      print(list(result_simpl_simple_before))
##      ##while the result of the simplification is different from the previous one
      while True:
#         ##Create new model to simplify from the first simplification result
         vars_declaration=open("vars_declaration.smt","r")
         if mode=='departure_states':
            interv_declaration=open('interv_declaration.smt','r')
         gene_perm_to_simplify=open('gene_perm_to_simplify_'+mode+'.smt',"w")
         gene_perm_to_simplify.write(vars_declaration.read())
         if mode=='departure_states':
            gene_perm_to_simplify.write(interv_declaration.read())
            interv_declaration.close()
         gene_perm_to_simplify.write("(assert \n")

         for l in range(len(result_simpl_before)):
#            print(result_simpl_simple_before[l])
            gene_perm_to_simplify.write(str(result_simpl_before[l]))

         gene_perm_to_simplify.write(")\n(apply ctx-solver-simplify) ")
         gene_perm_to_simplify.close()
         size_before=len(result_simpl_before)
         call('z3 gene_perm_to_simplify_'+mode+'.smt > result_simplif_gene_perm_'+mode,  shell=True)
         if mode=='univ':
            call('cp result_simplif_gene_perm_'+mode+' '+str(n)+'_result_simplif_gene_perm_'+mode, shell=True)         
         result_simpl='result_simplif_gene_perm_'+mode
         (lines) = utils.read_lines(result_simpl)
         result_simpl_after=lines[2:-2]
         size_after=len(result_simpl_after)
         result_simpl_before=copy.copy(result_simpl_after)
         result_simpl_after=[]
         n+=1
         if size_before==size_after:
            break
   result_simpl=copy.copy(result_simpl_before)   
#   print("This is result_simpl:")
#   print(list(result_simpl))
   
   open('gene_perm_to_simplify_'+mode+'.smt',"w").close()
   vars_declaration=open("vars_declaration.smt","r")
   to_simpl=open('gene_perm_to_simplify_'+mode+'.smt',"w")
   to_simpl.write(vars_declaration.read())
   vars_declaration.close()
   interv_declaration=open('interv_declaration.smt', 'r')
   to_simpl.write(interv_declaration.read())
   interv_declaration.close()
   if any('and' in r for r in result_simpl) or any('or' in r for r in result_simpl):
      to_simpl.write("(assert \n")
      for l in range(len(result_simpl)):
         #            print(result_simpl_simple_before[l])
         to_simpl.write(str(result_simpl[l]))
      to_simpl.write(')\n')
   else:
      for l in range(len(result_simpl)):
         to_simpl.write('(assert \n\t'+result_simpl[l]+')\n')
   to_simpl.write("(apply ctx-solver-simplify) ")
   to_simpl.close()
   return result_simpl  

def simplif_gene_store_arrival_states(result_simpl_univ_structure):
   to_simpl_arrival_st_structure=[]
   for r1 in result_simpl_univ_structure:
      if all(t.result_simpl!=r1.result_simpl for t in to_simpl_arrival_st_structure):
         to_simpl_arrival_st_structure.append(ResultSimpl([], r1.result_simpl))
      for t in to_simpl_arrival_st_structure:
         if t.result_simpl==r1.result_simpl:
            t.arrival_state_id.append(r1.arrival_state_id)
#   for t in to_simpl_arrival_st_structure:
#      print(list(t.result_simpl))
#      print(list(t.arrival_state_id))
   return to_simpl_arrival_st_structure      
   
def simplif_gene_declare_arrival_states(states_structure, arrival_states_ids):
   open("gene_perm_arrival_st_declaration.smt","w").close()
   
   result_simple_declaration=open("gene_perm_arrival_st_declaration.smt", "w")
   result_simple_declaration.write("(assert \n")
   result_simple=[]
   result_simple_lines=[]

   for arr_st_id in arrival_states_ids:
      result_simple=[]      
      formula_part_1=[]
      formula_part_2=[]
      for s in states_structure:
         if int(arr_st_id)==int(s.id):
            for v_n in s.vars_names:
               formula_part_1.append("(= "+v_n.split(".v")[0]+" "+v_n.split(".v")[0])
            for v_v in s.vars_values:
               formula_part_2.append(v_v+") ")
            for i in range(len(formula_part_1)):
               result_simple.append(formula_part_1[i]+formula_part_2[i])
      if len(result_simple)>1:
         result_simple_lines.append("\t\t(and "+(" ").join(result_simple)+")\n")
      if len(result_simple)==1:
         result_simple_lines.append(result_simple[0]+"\n")
            
   if (len(result_simple_lines))>1:
      result_simple_declaration.write("\n\t(or\n")
   if len(result_simple_lines)!=0:
      for l in result_simple_lines:
         result_simple_declaration.write(l)
   if (len(result_simple_lines))>1:
      result_simple_declaration.write("\t)\n")  
   
#   print("Lines of the declaration to simplify:\n")
#   print(list(result_simple_lines))
            
   result_simple_declaration.write(")\n")
   result_simple_declaration.write("(apply ctx-solver-simplify)\n")
   result_simple_declaration.close()

#def simplif_gene_clean():
#   call('rm gene_perm_arrival_st_declaration.smt result_simplif_gene_perm gene_perm_to_simplify.smt vars_declaration.smt ', shell=True)


def simplif_gene_main(variables_structure, states_structure, results_gene_simple_structure, results_no_univ_global_structure, nb_var, model_name, names_intervs):
      
   ##Declare the variables and types in smt
   simplif_gene_declare_vars(variables_structure)
   simplif_gene_declare_intervs(names_intervs)
#   print("Declared variables")  
   if all(r.is_reach=="true" for r in results_gene_simple_structure):
      print("All states are simply reachable")
   if len(results_no_univ_global_structure)==0:
      print('All states that are simply reachable also are universally reachable')
      
########################################################################   
##FOR SIMPLE PERMISSIVENESS RESULTS:
   if any(r.is_reach=="false" for r in results_gene_simple_structure):
      print('Simplifying simple permissiveness...')
      simplif_gene_declare_gene_perm_result(states_structure, results_gene_simple_structure, "simple", names_intervs)
      _ = simplif_gene_simplify(nb_var,'simple')
      parse_result=utils.parse_smt('gene_perm_to_simplify_simple.smt')
      to_write_smv=utils.write_smv_from_smt(parse_result, names_intervs)
      smv_file=open(model_name+'.result_simple','w')
      smv_file.write('DEFINE non_simple_reach := ')
      for i in range(len(to_write_smv)):
         smv_file.write(to_write_smv[i])
         if to_write_smv.index(to_write_smv[i])!=to_write_smv.index(to_write_smv[-1]):
            smv_file.write(' | ')
         else: smv_file.write(';')
      smv_file.close()
   
   
########################################################################   
##FOR UNIV PERMISSIVENESS RESULTS:
########################################################################
##SIMPLIFYING THE DEPARTURE PREDICATES FOR NON UNIV REACHABLE STATES
      
   results_simpl_arrival_states_structure=[]
   open(model_name+'.result_univ','w').close()
   for arrival_st in results_no_univ_global_structure:
      print('Simplifying univ permissiveness...')
      ##arrival_st is a state that is not universally reachable.
      ##arrival_st.pairs_results is a structure storing, for every state, if they can reach arrival_st
      if len(arrival_st.dep_state)>0:
         simplif_gene_declare_gene_perm_result(states_structure, arrival_st.dep_state, "departure_states", names_intervs)
         ##Simplifying the declarations  of the states that cannot reach arrival_st
         _=simplif_gene_simplify(nb_var, 'departure_states')
         parse_result=utils.parse_smt('gene_perm_to_simplify_departure_states.smt')
         to_write_smv=utils.write_smv_from_smt(parse_result, names_intervs)
         smv_file=open(model_name+'.result_univ','a')
         smv_file.write('\nDEFINE non_univ_reach_'+str(arrival_st.st_arrival_id)+' := ')
         for i in range(len(to_write_smv)):
            smv_file.write(to_write_smv[i])
            if to_write_smv.index(to_write_smv[i])!=to_write_smv.index(to_write_smv[-1]):
               smv_file.write(' | ')
            else: smv_file.write(';')
         smv_file.close()
         results_simpl_arrival_states_structure.append(ResultSimpl(arrival_st.st_arrival_id,to_write_smv))##store the number of the arrival state and the simplified formula of the departure states

########################################################################
##SIMPLIFYING THE SETS OF NON REACHABLE STATES THAT HAVE THE SAME DEPARTURE PREDICATE
   same_departure_pred_structure=[]
   for i in range(len(results_simpl_arrival_states_structure)):
      if all(stored_pred.departure_predicate!=results_simpl_arrival_states_structure[i].result_simpl for stored_pred in same_departure_pred_structure):
         ##If the predicate hasn't been stored yet, add it to the "same departure" structure and check what other arrival states have the same departure predicate
         same_departure_pred_structure.append(SameDeparture(results_simpl_arrival_states_structure[i].result_simpl, [results_simpl_arrival_states_structure[i].arrival_state_id]))
      else:
         for s in same_departure_pred_structure:
            if s.departure_predicate==results_simpl_arrival_states_structure[i].result_simpl:
               s.arrival_states_ids.append(results_simpl_arrival_states_structure[i].arrival_state_id)


   open(model_name+'.non_existing_paths','w').close()
   for s in same_departure_pred_structure:
#      print(s.departure_predicate)
#      print(s.arrival_states_ids)
      simplif_gene_declare_arrival_states(states_structure, s.arrival_states_ids)
      _=simplif_gene_simplify(nb_var, 'arrival_st')
      parse_result=utils.parse_smt('gene_perm_to_simplify_arrival_st.smt')
      to_write_smv=utils.write_smv_from_smt(parse_result, names_intervs)
      smv_file=open(model_name+'.non_existing_paths','a')
      smv_file.write('\n--No path from ')
      for i in  range(len(s.departure_predicate)):
         smv_file.write(s.departure_predicate[i])
         if s.departure_predicate.index(s.departure_predicate[i])!=s.departure_predicate.index(s.departure_predicate[-1]):
            smv_file.write(' | ')
         else: smv_file.write(';')
      smv_file.write('\n--To ')
      for i in range(len(to_write_smv)):
         smv_file.write(to_write_smv[i])
         if to_write_smv.index(to_write_smv[i])!=to_write_smv.index(to_write_smv[-1]):
            smv_file.write(' | ')
         else: smv_file.write(';')
      smv_file.write('\n\n----------------------------------------------------------------------\n')
      smv_file.close()
      
